/**
 * CG3 Skeletal Animation Project
 * Jason Winnebeck
 * May 12, 2003
 */

#ifndef GAMEDXLISTENER_H_WETB234
#define GAMEDXLISTENER_H_WETB234

/**
 * This is an interface for a listener who needs to listen to the GameDX class
 * for lost device and reset device events.  It is possible for a device to be
 * lost and never reset.
 *
 * Listeners wanting to listen to events must register with the global GameDX
 * object.
 */
class GameDXListener {
public:
    /**
     * Event called when device is lost.
     */
    virtual void OnLostDevice() = 0;

    /**
     * Event called when device is reset.
     */
    virtual void OnResetDevice() = 0;
};

#endif
