/**
 * CG3 Skeletal Animation Project
 * Jason Winnebeck
 * May 12, 2003
 */

#include "global.h"
#include "GameException.h"

GameException::GameException() : msg("unknown error") {
}

GameException::GameException( const std::string& msg ) : msg(msg) {
}

GameException::GameException( const std::string& msg, HRESULT errorCode ) {
    this->msg = msg + "\nDX Error Message: " + DXGetErrorString8( errorCode );
}

void GameException::showMessageBox() const {
    HWND hWnd = NULL;
    if ( g_win != NULL )
        hWnd = g_win->getHwnd();

    MessageBox( hWnd, msg.c_str(), "Error", MB_OK | MB_ICONWARNING );
}

const std::string& GameException::getMessage() const {
    return msg;
}

void GameException::addMessage( const std::string& m ) {
    msg += "\n";
    msg += m;
}
