/**
 * CG3 Skeletal Animation Project
 * Jason Winnebeck
 * May 12, 2003
 */

#include "global.h"

#ifndef GAMEEXCEPTION_H_DFWER234
#define GAMEEXCEPTION_H_DFWER234

/**
 * The GameException is the base class for exceptions in Super IsoBomb.
 */
class GameException {
public:
    /**
     * Creates a new exception with the message "unknown error".
     */
    GameException();

    /**
     * Creates a new exception with the specified message.
     */
    explicit GameException( const std::string& msg );

    /**
     * Creates a new exception with the specified message and HRESULT error
     * code.
     */
    GameException( const std::string& msg, HRESULT errorCode );

    /**
     * Displays an appropriate message box to the user containing this
     * exception's message.
     */
    void showMessageBox() const;

    /**
     * Returns this exception's message string.
     */
    const std::string& getMessage() const;

    /**
     * Adds a line to this exception's message string.  The string "\n"
     * followed by m is appended to this GameException's message.
     */
    void addMessage( const std::string& m );

private:
    std::string msg;
};

#endif //#ifdef GAMEEXCEPTION_H_DFWER234
