#include "global.h"
#include "Keyframes.h"

bool Key::operator < ( const Key& rhs ) const {
    return time < rhs.time;
}

bool Key::operator > ( const Key& rhs ) const {
    return time > rhs.time;
}

bool Key::operator < ( float rhs ) const {
    return time < rhs;
}

bool Key::operator > ( float rhs ) const {
    return time > rhs;
}

bool Key::operator >= ( float rhs ) const {
    return time >= rhs;
}
    
bool Key::operator <= ( float rhs ) const {
    return time <= rhs;
}

RotKey RotKey::interp( const RotKey& next, float atTime ) const {
    float frac = (atTime - time) / (next.time - time);
    RotKey ret;
    ret.time = atTime;
    D3DXQuaternionSlerp( &ret.rot, &rot, &next.rot, frac );
    return ret;
}

VectKey VectKey::interp( const VectKey& next, float atTime ) const {
    float frac = (atTime - time) / (next.time - time);
    VectKey ret;
    ret.time = atTime;
    D3DXVec3Lerp( &ret.v, &v, &next.v, frac );
    return ret;
}
