/**
 * CG3 Skeletal Animation Project
 * Jason Winnebeck
 * May 12, 2003
 */

#ifndef _TIMER_H_
#define _TIMER_H_


class Timer {

public:
   
    /**
     * Returns the frame rate
     *
     * @returns                 the current frame rate
     */
    int getFrameRate();

    /**
     * Starts the timer
     *
     */
    void setStartTime();

    /**
     * Returns the number of seconds that have passed since the timer was
     * started.
     */
    float getSecondsSinceStart();

    /**
     * Returns the number of ticks per millisecond
     *
     * @returns                 the number of ticks per millisecond
     */
    float getNumTicksPerMs();

    /**
     * Calculates the frame rate
     *
     */
    void calcFrameCount();

    /**
     * Calculates and returns the number of seconds that have passed 
     * since the last frame
     *
     * @returns the number of seconds that have passed since the last frame
     */
    float getFrameDt();
	

    /**
     * Constructor
     *
     */
    Timer();

    /**
     * Destructor
     *
     */
    ~Timer();

private:

    /**
     * The frame rate
     *
     */
    int time_FrameRate;

    /**
     * The frequency
     *
     */
    INT64 time_Frequency;

    /**
     * The start time
     *
     */
    INT64 time_StartTime;

    /**
     * The frame count 
     *
     */
    int time_FrameCount;

    /**
     * The time the last frame began
     */
    float time_LastFrame;

};

#endif


